Magisk/scripts/util_functions.sh

427 lines
12 KiB
Bash
Raw Normal View History

2017-06-18 18:15:44 +02:00
##########################################################################################
#
2017-06-18 18:15:44 +02:00
# Magisk General Utility Functions
# by topjohnwu
#
2017-09-13 09:44:35 +02:00
# Used everywhere in Magisk
#
2017-06-18 18:15:44 +02:00
##########################################################################################
2017-12-20 20:36:18 +01:00
#MAGISK_VERSION_STUB
2017-07-10 19:54:11 +02:00
2018-01-01 09:46:28 +01:00
# Detect whether in boot mode
ps | grep zygote | grep -v grep >/dev/null && BOOTMODE=true || BOOTMODE=false
$BOOTMODE || ps -A 2>/dev/null | grep zygote | grep -v grep >/dev/null && BOOTMODE=true
$BOOTMODE || id | grep -q 'uid=0' || BOOTMODE=true
# Default location, will override if needed
2017-12-25 20:23:58 +01:00
MAGISKBIN=/data/adb/magisk
2017-12-28 21:25:30 +01:00
[ -z $MOUNTPATH ] && MOUNTPATH=/sbin/.core/img
2017-12-25 20:23:58 +01:00
[ -z $IMG ] && IMG=/data/adb/magisk.img
BOOTSIGNER="/system/bin/dalvikvm -Xnodex2oat -Xnoimage-dex2oat -cp \$APK com.topjohnwu.magisk.utils.BootSigner"
2017-10-31 10:05:24 +01:00
BOOTSIGNED=false
2017-07-09 18:17:34 +02:00
get_outfd() {
if [ $OUTFD -eq 1 ]; then
# We will have to manually find out OUTFD
for FD in `ls /proc/self/fd`; do
if readlink /proc/self/fd/$FD | grep -q pipe; then
if ps | grep -v grep | grep -q " 3 $FD "; then
2017-07-09 18:17:34 +02:00
OUTFD=$FD
break
fi
fi
done
fi
}
2017-06-18 18:15:44 +02:00
ui_print() {
2017-10-07 16:08:10 +02:00
$BOOTMODE && echo "$1" || echo -e "ui_print $1\nui_print" >> /proc/self/fd/$OUTFD
2017-06-18 18:15:44 +02:00
}
2018-06-20 19:37:08 +02:00
toupper() {
echo "$@" | tr '[:lower:]' '[:upper:]'
}
find_block() {
for uevent in /sys/dev/block/*/uevent; do
local DEVNAME=`grep_prop DEVNAME $uevent`
local PARTNAME=`grep_prop PARTNAME $uevent`
for p in "$@"; do
if [ "`toupper $p`" = "`toupper $PARTNAME`" ]; then
echo /dev/block/$DEVNAME
return 0
fi
done
done
return 1
}
2017-09-12 22:07:25 +02:00
mount_partitions() {
# Check A/B slot
2018-06-20 19:37:08 +02:00
SLOT=`grep_cmdline androidboot.slot_suffix`
if [ -z $SLOT ]; then
SLOT=_`grep_cmdline androidboot.slot`
[ $SLOT = "_" ] && SLOT=
2017-11-10 18:33:50 +01:00
fi
2018-06-20 19:37:08 +02:00
[ -z $SLOT ] || ui_print "- Current boot slot: $SLOT"
2018-01-01 09:46:28 +01:00
2017-09-12 22:07:25 +02:00
ui_print "- Mounting /system, /vendor"
2018-06-17 11:59:24 +02:00
[ -f /system/build.prop ] || is_mounted /system || mount -o ro /system 2>/dev/null
2017-09-12 22:07:25 +02:00
if ! is_mounted /system && ! [ -f /system/build.prop ]; then
2018-06-20 19:37:08 +02:00
SYSTEMBLOCK=`find_block system$SLOT`
2017-09-12 22:07:25 +02:00
mount -t ext4 -o ro $SYSTEMBLOCK /system
fi
2018-06-17 11:59:24 +02:00
[ -f /system/build.prop ] || is_mounted /system || abort "! Cannot mount /system"
cat /proc/mounts | grep -E '/dev/root|/system_root' >/dev/null && SYSTEM_ROOT=true || SYSTEM_ROOT=false
if [ -f /system/init ]; then
SYSTEM_ROOT=true
2017-09-12 22:07:25 +02:00
mkdir /system_root 2>/dev/null
mount --move /system /system_root
mount -o bind /system_root/system /system
fi
2018-06-17 11:59:24 +02:00
$SYSTEM_ROOT && ui_print "- Device using system_root_image"
2017-09-12 22:07:25 +02:00
if [ -L /system/vendor ]; then
# Seperate /vendor partition
is_mounted /vendor || mount -o ro /vendor 2>/dev/null
if ! is_mounted /vendor; then
2018-06-20 19:37:08 +02:00
VENDORBLOCK=`find_block vendor$SLOT`
2017-09-12 22:07:25 +02:00
mount -t ext4 -o ro $VENDORBLOCK /vendor
fi
is_mounted /vendor || abort "! Cannot mount /vendor"
fi
}
get_flags() {
# override variables
getvar KEEPVERITY
getvar KEEPFORCEENCRYPT
HIGHCOMP=false
if [ -z $KEEPVERITY ]; then
KEEPVERITY=false
hardware=`grep_cmdline androidboot.hardware`
for hw in taimen walleye; do
if [ "$hw" = "$hardware" ]; then
KEEPVERITY=true
ui_print "- Device on whitelist, keep avb-verity"
break
fi
done
fi
if [ -z $KEEPFORCEENCRYPT ]; then
if [ "`getprop ro.crypto.state`" = "encrypted" ]; then
KEEPFORCEENCRYPT=true
ui_print "- Encrypted data detected, keep forceencrypt"
else
KEEPFORCEENCRYPT=false
fi
fi
}
2018-06-17 11:59:24 +02:00
grep_cmdline() {
2018-06-20 19:37:08 +02:00
local REGEX="s/^$1=//p"
2018-06-17 11:59:24 +02:00
sed -E 's/ +/\n/g' /proc/cmdline | sed -n "$REGEX" 2>/dev/null
}
2017-07-30 21:03:52 +02:00
grep_prop() {
2018-06-20 19:37:08 +02:00
local REGEX="s/^$1=//p"
2017-07-30 21:03:52 +02:00
shift
2018-06-20 19:37:08 +02:00
local FILES=$@
2017-07-30 21:03:52 +02:00
[ -z "$FILES" ] && FILES='/system/build.prop'
sed -n "$REGEX" $FILES 2>/dev/null | head -n 1
}
2017-06-18 18:15:44 +02:00
getvar() {
local VARNAME=$1
2018-02-09 20:34:13 +01:00
local VALUE=
2018-06-17 11:59:24 +02:00
VALUE=`grep_prop $VARNAME /.backup/.magisk /data/.magisk /cache/.magisk /system/.magisk`
2018-02-09 20:34:13 +01:00
[ ! -z $VALUE ] && eval $VARNAME=\$VALUE
2017-09-26 14:21:43 +02:00
}
2018-01-01 09:46:28 +01:00
run_migrations() {
2017-09-06 10:13:23 +02:00
# Update the broken boot backup
if [ -f /data/stock_boot_.img.gz ]; then
$MAGISKBIN/magiskboot --decompress /data/stock_boot_.img.gz /data/stock_boot.img
2017-09-06 10:13:23 +02:00
fi
# Update our previous backup to new format if exists
if [ -f /data/stock_boot.img ]; then
ui_print "- Migrating boot image backup"
SHA1=`$MAGISKBIN/magiskboot --sha1 /data/stock_boot.img 2>/dev/null`
2017-09-06 10:13:23 +02:00
STOCKDUMP=/data/stock_boot_${SHA1}.img
mv /data/stock_boot.img $STOCKDUMP
$MAGISKBIN/magiskboot --compress $STOCKDUMP
2017-09-06 10:13:23 +02:00
fi
2018-01-01 09:46:28 +01:00
# Move the stock backups
if [ -f /data/magisk/stock_boot* ]; then
rm -rf /data/stock_boot*
mv /data/magisk/stock_boot* /data 2>/dev/null
fi
if [ -f /data/adb/magisk/stock_boot* ]; then
rm -rf /data/stock_boot*
mv /data/adb/magisk/stock_boot* /data 2>/dev/null
fi
# Remove old dbs
rm -f /data/user*/*/magisk.db
2018-02-09 20:34:13 +01:00
[ -L /data/magisk.img ] || mv /data/magisk.img /data/adb/magisk.img 2>/dev/null
2017-09-26 14:21:43 +02:00
}
2018-06-20 19:37:08 +02:00
find_boot_image() {
BOOTIMAGE=
if [ ! -z $SLOT ]; then
BOOTIMAGE=`find_block boot$SLOT ramdisk$SLOT`
else
BOOTIMAGE=`find_block boot_a kern-a android_boot kernel boot lnx bootimg`
fi
}
2017-09-26 14:21:43 +02:00
flash_boot_image() {
# Make sure all blocks are writable
$MAGISKBIN/magisk --unlock-blocks 2>/dev/null
2017-09-26 14:21:43 +02:00
case "$1" in
2017-11-10 18:33:50 +01:00
*.gz) COMMAND="gzip -d < '$1'";;
*) COMMAND="cat '$1'";;
2017-09-26 14:21:43 +02:00
esac
2018-02-09 20:34:13 +01:00
if $BOOTSIGNED; then
SIGNCOM="$BOOTSIGNER -sign"
ui_print "- Sign boot image with test keys"
else
SIGNCOM="cat -"
fi
2017-09-26 14:21:43 +02:00
case "$2" in
/dev/block/*)
ui_print "- Flashing new boot image"
2017-11-10 18:33:50 +01:00
eval $COMMAND | eval $SIGNCOM | cat - /dev/zero 2>/dev/null | dd of="$2" bs=4096 2>/dev/null
2017-09-26 14:21:43 +02:00
;;
*)
ui_print "- Storing new boot image"
2017-11-10 18:33:50 +01:00
eval $COMMAND | eval $SIGNCOM | dd of="$2" bs=4096 2>/dev/null
2017-09-26 14:21:43 +02:00
;;
esac
2017-09-06 10:13:23 +02:00
}
2017-11-10 18:33:50 +01:00
find_dtbo_image() {
2018-06-20 19:37:08 +02:00
DTBOIMAGE=`find_block dtbo$SLOT`
2017-11-10 18:33:50 +01:00
}
patch_dtbo_image() {
if [ ! -z $DTBOIMAGE ]; then
if $MAGISKBIN/magiskboot --dtb-test $DTBOIMAGE; then
2017-11-10 18:33:50 +01:00
ui_print "- Backing up stock dtbo image"
$MAGISKBIN/magiskboot --compress $DTBOIMAGE $MAGISKBIN/stock_dtbo.img.gz
2017-11-10 18:33:50 +01:00
ui_print "- Patching fstab in dtbo to remove avb-verity"
$MAGISKBIN/magiskboot --dtb-patch $DTBOIMAGE
return 0
2017-11-10 18:33:50 +01:00
fi
fi
return 1
2017-11-10 18:33:50 +01:00
}
restore_imgs() {
STOCKBOOT=/data/stock_boot_${1}.img.gz
STOCKDTBO=/data/stock_dtbo.img.gz
# Make sure all blocks are writable
$MAGISKBIN/magisk --unlock-blocks 2>/dev/null
2017-11-10 18:33:50 +01:00
find_dtbo_image
if [ ! -z "$DTBOIMAGE" -a -f "$STOCKDTBO" ]; then
ui_print "- Restoring stock dtbo image"
gzip -d < $STOCKDTBO | dd of=$DTBOIMAGE
fi
BOOTSIGNED=false
find_boot_image
if [ ! -z "$BOOTIMAGE" -a -f "$STOCKBOOT" ]; then
ui_print "- Restoring stock boot image"
gzip -d < $STOCKBOOT | cat - /dev/zero 2>/dev/null | dd of="$BOOTIMAGE" bs=4096 2>/dev/null
2017-11-10 18:33:50 +01:00
return 0
fi
return 1
}
2017-09-06 10:13:23 +02:00
sign_chromeos() {
2017-10-07 16:08:10 +02:00
ui_print "- Signing ChromeOS boot image"
2017-09-06 10:13:23 +02:00
2017-10-07 16:08:10 +02:00
echo > empty
./chromeos/futility vbutil_kernel --pack new-boot.img.signed \
2017-09-06 10:13:23 +02:00
--keyblock ./chromeos/kernel.keyblock --signprivate ./chromeos/kernel_data_key.vbprivk \
--version 1 --vmlinuz new-boot.img --config empty --arch arm --bootloader empty --flags 0x1
rm -f empty new-boot.img
mv new-boot.img.signed new-boot.img
}
2017-06-18 18:15:44 +02:00
is_mounted() {
2018-06-17 11:59:24 +02:00
cat /proc/mounts | grep -q " `readlink -f $1` " 2>/dev/null
2017-06-18 18:15:44 +02:00
return $?
}
remove_system_su() {
if [ -f /system/bin/su -o -f /system/xbin/su ] && [ ! -f /su/bin/su ]; then
ui_print "! System installed root detected, mount rw :("
mount -o rw,remount /system
# SuperSU
if [ -e /system/bin/.ext/.su ]; then
mv -f /system/bin/app_process32_original /system/bin/app_process32 2>/dev/null
mv -f /system/bin/app_process64_original /system/bin/app_process64 2>/dev/null
mv -f /system/bin/install-recovery_original.sh /system/bin/install-recovery.sh 2>/dev/null
cd /system/bin
if [ -e app_process64 ]; then
ln -sf app_process64 app_process
else
ln -sf app_process32 app_process
fi
fi
rm -rf /system/.pin /system/bin/.ext /system/etc/.installed_su_daemon /system/etc/.has_su_daemon \
/system/xbin/daemonsu /system/xbin/su /system/xbin/sugote /system/xbin/sugote-mksh /system/xbin/supolicy \
/system/bin/app_process_init /system/bin/su /cache/su /system/lib/libsupol.so /system/lib64/libsupol.so \
/system/su.d /system/etc/install-recovery.sh /system/etc/init.d/99SuperSUDaemon /cache/install-recovery.sh \
/system/.supersu /cache/.supersu /data/.supersu \
/system/app/Superuser.apk /system/app/SuperSU /cache/Superuser.apk 2>/dev/null
fi
}
2017-07-02 15:36:09 +02:00
api_level_arch_detect() {
API=`grep_prop ro.build.version.sdk`
ABI=`grep_prop ro.product.cpu.abi | cut -c-3`
ABI2=`grep_prop ro.product.cpu.abi2 | cut -c-3`
ABILONG=`grep_prop ro.product.cpu.abi`
ARCH=arm
2018-04-22 08:13:27 +02:00
ARCH32=arm
2017-07-02 15:36:09 +02:00
IS64BIT=false
2018-04-22 08:13:27 +02:00
if [ "$ABI" = "x86" ]; then ARCH=x86; ARCH32=x86; fi;
if [ "$ABI2" = "x86" ]; then ARCH=x86; ARCH32=x86; fi;
if [ "$ABILONG" = "arm64-v8a" ]; then ARCH=arm64; ARCH32=arm; IS64BIT=true; fi;
if [ "$ABILONG" = "x86_64" ]; then ARCH=x64; ARCH32=x86; IS64BIT=true; fi;
2017-07-02 15:36:09 +02:00
}
setup_bb() {
2018-06-21 10:39:10 +02:00
if [ -x /sbin/.core/busybox/busybox ]; then
# Make sure this path is in the front
echo $PATH | grep -q '^/sbin/.core/busybox' || export PATH=/sbin/.core/busybox:$PATH
elif [ -x $TMPDIR/bin/busybox ]; then
# Make sure this path is in the front
echo $PATH | grep -q "^$TMPDIR/bin" || export PATH=$TMPDIR/bin:$PATH
else
# Construct the PATH
mkdir -p $TMPDIR/bin
ln -s $MAGISKBIN/busybox $TMPDIR/bin/busybox
$MAGISKBIN/busybox --install -s $TMPDIR/bin
export PATH=$TMPDIR/bin:$PATH
fi
}
2017-08-12 10:44:58 +02:00
boot_actions() {
2017-11-22 09:04:24 +01:00
if [ ! -d /sbin/.core/mirror/bin ]; then
mkdir -p /sbin/.core/mirror/bin
mount -o bind $MAGISKBIN /sbin/.core/mirror/bin
2017-08-12 10:44:58 +02:00
fi
2017-11-22 09:04:24 +01:00
MAGISKBIN=/sbin/.core/mirror/bin
setup_bb
2017-08-12 10:44:58 +02:00
}
2017-06-24 16:38:20 +02:00
recovery_actions() {
# TWRP bug fix
mount -o bind /dev/urandom /dev/random
# Preserve environment varibles
OLD_PATH=$PATH
setup_bb
2017-06-24 16:38:20 +02:00
# Temporarily block out all custom recovery binaries/libs
mv /sbin /sbin_tmp
# Unset library paths
OLD_LD_LIB=$LD_LIBRARY_PATH
OLD_LD_PRE=$LD_PRELOAD
unset LD_LIBRARY_PATH
unset LD_PRELOAD
2017-07-02 15:36:09 +02:00
}
recovery_cleanup() {
2017-07-30 21:03:52 +02:00
mv /sbin_tmp /sbin 2>/dev/null
[ -z $OLD_PATH ] || export PATH=$OLD_PATH
[ -z $OLD_LD_LIB ] || export LD_LIBRARY_PATH=$OLD_LD_LIB
[ -z $OLD_LD_PRE ] || export LD_PRELOAD=$OLD_LD_PRE
2017-07-02 15:36:09 +02:00
ui_print "- Unmounting partitions"
2017-09-12 22:07:25 +02:00
umount -l /system_root 2>/dev/null
2017-07-30 21:03:52 +02:00
umount -l /system 2>/dev/null
2017-07-02 15:36:09 +02:00
umount -l /vendor 2>/dev/null
2017-07-30 21:03:52 +02:00
umount -l /dev/random 2>/dev/null
2017-06-24 16:38:20 +02:00
}
2017-06-18 18:15:44 +02:00
abort() {
ui_print "$1"
2017-07-30 21:03:52 +02:00
$BOOTMODE || recovery_cleanup
2017-06-18 18:15:44 +02:00
exit 1
}
2017-07-09 18:17:34 +02:00
set_perm() {
2018-02-09 20:34:13 +01:00
chown $2:$3 $1 || return 1
chmod $4 $1 || return 1
[ -z $5 ] && chcon 'u:object_r:system_file:s0' $1 || chcon $5 $1 || return 1
2017-07-09 18:17:34 +02:00
}
set_perm_recursive() {
find $1 -type d 2>/dev/null | while read dir; do
set_perm $dir $2 $3 $4 $6
done
2017-07-30 21:03:52 +02:00
find $1 -type f -o -type l 2>/dev/null | while read file; do
2017-07-09 18:17:34 +02:00
set_perm $file $2 $3 $5 $6
done
}
mktouch() {
2017-07-30 21:03:52 +02:00
mkdir -p ${1%/*} 2>/dev/null
[ -z $2 ] && touch $1 || echo $2 > $1
2017-07-09 18:17:34 +02:00
chmod 644 $1
}
request_size_check() {
reqSizeM=`du -s $1 | cut -f1`
reqSizeM=$((reqSizeM / 1024 + 1))
}
request_zip_size_check() {
reqSizeM=`unzip -l "$1" | tail -n 1 | awk '{ print int($1 / 1048567 + 1) }'`
}
2017-07-09 18:17:34 +02:00
image_size_check() {
SIZE="`$MAGISKBIN/magisk --imgsize $IMG`"
2017-07-09 18:17:34 +02:00
curUsedM=`echo "$SIZE" | cut -d" " -f1`
curSizeM=`echo "$SIZE" | cut -d" " -f2`
curFreeM=$((curSizeM - curUsedM))
}
2017-12-25 20:23:58 +01:00
mount_magisk_img() {
[ -z reqSizeM ] && reqSizeM=0
if [ -f "$IMG" ]; then
ui_print "- Found $IMG"
image_size_check $IMG
if [ "$reqSizeM" -gt "$curFreeM" ]; then
newSizeM=$(((reqSizeM + curUsedM) / 32 * 32 + 64))
ui_print "- Resizing $IMG to ${newSizeM}M"
$MAGISKBIN/magisk --resizeimg $IMG $newSizeM >&2
2017-12-25 20:23:58 +01:00
fi
else
newSizeM=$((reqSizeM / 32 * 32 + 64));
ui_print "- Creating $IMG with size ${newSizeM}M"
$MAGISKBIN/magisk --createimg $IMG $newSizeM >&2
2017-12-25 20:23:58 +01:00
fi
ui_print "- Mounting $IMG to $MOUNTPATH"
2018-06-03 11:00:42 +02:00
mkdir -p $MOUNTPATH 2>/dev/null
MAGISKLOOP=`$MAGISKBIN/magisk --mountimg $IMG $MOUNTPATH`
2017-12-25 20:23:58 +01:00
is_mounted $MOUNTPATH || abort "! $IMG mount failed..."
}
unmount_magisk_img() {
$MAGISKBIN/magisk --umountimg $MOUNTPATH $MAGISKLOOP
2017-12-25 20:23:58 +01:00
# Shrink the image if possible
image_size_check $IMG
newSizeM=$((curUsedM / 32 * 32 + 64))
if [ $curSizeM -gt $newSizeM ]; then
ui_print "- Shrinking $IMG to ${newSizeM}M"
$MAGISKBIN/magisk --resizeimg $IMG $newSizeM
2017-12-25 20:23:58 +01:00
fi
}